/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is JavaScript for Wireless Markup Language emulation
 *
 * Contributor(s):
 *      Raoul Nakhmanson-Kulish <manko@zhurnal.ru>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or 
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function nsWMLgetValue(val,mode,name) {
    var valSrcElement = self.document.getElementById(val);
    if (valSrcElement) {
        switch(valSrcElement.nodeName.toLowerCase()) {
            case "input":
                return valSrcElement.value;
                break;
            case "select":
                var retVal = "";
                for (var i = 0; i < valSrcElement.options.length; i++) {
                    if (valSrcElement.options[i].selected) {
                        if (retVal!="") {
                            retVal+= (mode == "value") ? "," : name + "="
                        }
                        if (mode == "href") {
                            retVal += escape(valSrcElement.options[i].value)
                        } else {
                            retVal += valSrcElement.options[i].value
                        }
                    }
                }
                return retVal;
                break;
        }
    } else return ""
}

function nsWMLreplaceValues(str,mode) {
    mode = (mode) ? mode : "href";
    var valPos;
    while ((valPos = str.indexOf("$(")) > -1) {
        var valEndPos = str.indexOf(")", valPos + 2);
        if (valEndPos == -1) valEndPos = str.length;
        var valName = str.substring(valPos + 2, valEndPos);
        var valFormName = valName;
        if (mode == "href" && valPos > 0 && str.charAt(valPos - 1) == "=") {
            var allowedNameChars = /(\w|\.|-|%[\dA-Fa-f]{2})+$/;
            var namesArray = allowedNameChars.exec(str.substring(0,valPos - 1));
            if (namesArray.length) valFormName = namesArray[0]
        }
        var valValue = (valName != "") ? nsWMLgetValue(valName,mode,valFormName) : "";
        str = str.substring(0, valPos) + valValue + str.substring(valEndPos + 1);
    }
    return str
}

function nsWMLcheckSelect(selectElement) {
    var inputIvalueElement = selectElement.nextSibling;
    while (inputIvalueElement && inputIvalueElement.nodeType != 1) {
        inputIvalueElement = inputIvalueElement.nextSibling
    }
    if (inputIvalueElement &&
                inputIvalueElement.nodeName.toLowerCase() == "input" &&
                inputIvalueElement.className == "ivalue") {
        var iValue = "";
        for (var i = 0; i < selectElement.options.length; i++) {
            if (selectElement.options[i].selected) {
                if (iValue != "") iValue += ",";
                iValue += i
            }
        }
        inputIvalueElement.value = iValue
    }
}

function nsWMLcheckLink(linkElement) {
    linkElement.href = nsWMLreplaceValues(linkElement.href, "href");
    return true
}

function nsWMLresetForms() {
    var inputsArray=document.getElementsByTagName("input")
    for (var i = 0; i < inputsArray.length; i++) {
        inputsArray[i].value = inputsArray[i].defaultValue
    }
    var selectsArray=document.getElementsByTagName("select")
    for (var i = 0; i < selectsArray.length; i++) with (selectsArray[i]) {
        for (var j = 0; j < options.length; j++) {
            options[j].selected = options[j].defaultSelected
        }
    }
}

function nsWMLcheckForm(formElement) {
    var actionIsPost = formElement.action.toLowerCase() == "post";
    formElement.action = nsWMLreplaceValues(formElement.action, "href");
    with (formElement) for (var i = 0; i < elements.length; i++) {
        if (elements[i].type == "hidden" &&
                elements[i].name) {
            elements[i].name = nsWMLreplaceValues(elements[i].name,"value");
            elements[i].value = nsWMLreplaceValues(elements[i].value,"value")
            if (!actionIsPost) {
                formElement.action += "&" + escape(elements[i].name) + "=" + escape(elements[i].value)
            }
        }
    }
    if (!actionIsPost) location.href=formElement.action;
    return actionIsPost
}
